# StochasticDiffEqLowOrder.jl

[![Join the chat at https://julialang.zulipchat.com #sciml-bridged](https://img.shields.io/static/v1?label=Zulip&message=chat&color=9558b2&labelColor=389826)](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
[![Global Docs](https://img.shields.io/badge/docs-SciML-blue.svg)](https://docs.sciml.ai/DiffEqDocs/stable/solvers/sde_solve/)

[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor%27s%20Guide-blueviolet)](https://github.com/SciML/ColPrac)
[![SciML Code Style](https://img.shields.io/static/v1?label=code%20style&message=SciML&color=9558b2&labelColor=389826)](https://github.com/SciML/SciMLStyle)

StochasticDiffEqLowOrder.jl is a component of the [OrdinaryDiffEq.jl](https://github.com/SciML/OrdinaryDiffEq.jl) monorepo providing low-order stochastic differential equation solvers. While completely independent and usable on its own, users wanting all SDE solvers should use [StochasticDiffEq.jl](https://github.com/SciML/StochasticDiffEq.jl).

## Solvers

- `EM` - Euler-Maruyama (strong order 0.5)
- `EulerHeun` - Euler-Heun (Stratonovich interpretation, strong order 0.5)
- `LambaEM` - Adaptive Euler-Maruyama
- `LambaEulerHeun` - Adaptive Euler-Heun (Stratonovich)
- `SimplifiedEM` - Simplified Euler-Maruyama
- `SplitEM` - Split-step Euler-Maruyama for split problems
- `RKMil` - Runge-Kutta Milstein (strong order 1.0, diagonal noise)
- `RKMilCommute` - Milstein for commutative noise
- `PCEuler` - Predictor-corrector Euler

## Example

```julia
using StochasticDiffEqLowOrder
f(u, p, t) = 1.01 * u
g(u, p, t) = 0.87 * u
u0 = 0.5
tspan = (0.0, 1.0)
prob = SDEProblem(f, g, u0, tspan)
sol = solve(prob, EM(), dt = 0.01)
```

## Available Solvers

For the full list of available SDE solvers, refer to the [DifferentialEquations.jl SDE Solvers](https://docs.sciml.ai/DiffEqDocs/stable/solvers/sde_solve/) documentation.

@muladd function perform_step!(integrator, cache::SplitEMConstantCache)
    (; t, dt, uprev, u, W, p, f) = integrator
    u = dt * (
        integrator.f.f1(uprev, p, t) +
            integrator.f.f2(uprev, p, t)
    ) +
        integrator.f.g(uprev, p, t) .* W.dW + uprev
    integrator.u = u
end

@muladd function perform_step!(integrator, cache::SplitEMCache)
    (; rtmp1, rtmp2) = cache
    (; t, dt, uprev, u, W, p, f) = integrator

    integrator.f.g(rtmp2, uprev, p, t)
    if is_diagonal_noise(integrator.sol.prob)
        rmul!(rtmp2, W.dW) # rtmp2 === rtmp3
        @.. u = uprev + rtmp2
    else
        mul!(rtmp1, rtmp2, W.dW)
        @.. u = uprev + rtmp1
    end

    integrator.f.f1(t, uprev, rtmp1)
    @.. u += dt * rtmp1
    integrator.f.f2(t, uprev, rtmp1)
    @.. u += dt * rtmp1
end

alg_order(alg::EM) = 1 // 2
alg_order(alg::LambaEM) = 1 // 2
alg_order(alg::SplitEM) = 1 // 2
alg_order(alg::PCEuler) = 1 // 2
alg_order(alg::EulerHeun) = 1 // 2
alg_order(alg::LambaEulerHeun) = 1 // 2
alg_order(alg::SimplifiedEM) = 1 // 2
alg_order(alg::RKMil) = 1 // 1
alg_order(alg::RKMilCommute) = 1 // 1

function SciMLBase.alg_interpretation(alg::EulerHeun)
    return SciMLBase.AlgorithmInterpretation.Stratonovich
end
function SciMLBase.alg_interpretation(alg::LambaEulerHeun)
    return SciMLBase.AlgorithmInterpretation.Stratonovich
end
function SciMLBase.alg_interpretation(alg::RKMil{interpretation}) where {interpretation}
    return interpretation
end
SciMLBase.alg_interpretation(alg::RKMilCommute) = alg.interpretation

supports_regular_jumps(::EM) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::EM) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::LambaEM) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::EulerHeun) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::LambaEulerHeun) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::SplitEM) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::PCEuler) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::SimplifiedEM) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::RKMil) = is_diagonal_noise(prob)
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::RKMilCommute) = true

is_split_step(::EM{split}) where {split} = split
is_split_step(::LambaEM{split}) where {split} = split

issplit(::SplitEM) = true

@muladd function perform_step!(integrator, cache::EMConstantCache)
    (; t, dt, uprev, u, W, P, c, p, f) = integrator

    K = uprev .+ dt .* integrator.f(uprev, p, t)

    if is_split_step(integrator.alg)
        u_choice = K
    else
        u_choice = uprev
    end

    if !is_diagonal_noise(integrator.sol.prob) || W.dW isa Number
        noise = integrator.f.g(u_choice, p, t) * W.dW
    else
        noise = integrator.f.g(u_choice, p, t) .* W.dW
    end

    if P !== nothing
        tmp = c(uprev, p, t, P.dW, nothing)
        u = K + noise + tmp
    else
        u = K + noise
    end
    integrator.u = u
end

@muladd function perform_step!(integrator, cache::EMCache)
    (; tmp, rtmp1, rtmp2) = cache
    (; t, dt, uprev, u, W, P, c, p) = integrator
    integrator.f(rtmp1, uprev, p, t)

    @.. u = uprev + dt * rtmp1

    if is_split_step(integrator.alg)
        u_choice = u
    else
        u_choice = uprev
    end

    integrator.f.g(rtmp2, u_choice, p, t)

    if P !== nothing
        c(tmp, uprev, p, t, P.dW, nothing)
    end

    if is_diagonal_noise(integrator.sol.prob)
        @.. rtmp2 *= W.dW
        if P !== nothing
            @.. u += rtmp2 + tmp
        else
            @.. u += rtmp2
        end
    else
        mul!(rtmp1, rtmp2, W.dW)
        if P !== nothing
            @.. u += rtmp1 + tmp
        else
            @.. u += rtmp1
        end
    end
end

@muladd function perform_step!(integrator, cache::EulerHeunConstantCache)
    (; t, dt, uprev, u, W, p, f) = integrator
    ftmp = integrator.f(uprev, p, t)
    gtmp = integrator.f.g(uprev, p, t)
    if is_diagonal_noise(integrator.sol.prob)
        noise = gtmp .* W.dW
    else
        noise = gtmp * W.dW
    end
    tmp = @.. uprev + dt * ftmp + noise
    gtmp2 = (gtmp .+ integrator.f.g(tmp, p, t + dt)) ./ 2
    if is_diagonal_noise(integrator.sol.prob)
        noise2 = gtmp2 .* W.dW
    else
        noise2 = gtmp2 * W.dW
    end
    u = uprev .+ (dt / 2) .* (ftmp .+ integrator.f(tmp, p, t + dt)) .+ noise2
    integrator.u = u
end

@muladd function perform_step!(integrator, cache::EulerHeunCache)
    (; ftmp1, ftmp2, gtmp1, gtmp2, tmp, nrtmp) = cache
    (; t, dt, uprev, u, W, p, f) = integrator
    integrator.f(ftmp1, uprev, p, t)
    integrator.f.g(gtmp1, uprev, p, t)

    if is_diagonal_noise(integrator.sol.prob)
        @.. nrtmp = gtmp1 * W.dW
    else
        mul!(nrtmp, gtmp1, W.dW)
    end

    @.. tmp = uprev + dt * ftmp1 + nrtmp

    integrator.f(ftmp2, tmp, p, t + dt)
    integrator.f.g(gtmp2, tmp, p, t + dt)

    if is_diagonal_noise(integrator.sol.prob)
        @.. nrtmp = W.dW * (gtmp1 + gtmp2) / 2
    else
        # nrtmp already contains gtmp1 * W.dW from stage 1.
        # By linearity: 0.5*(gtmp1+gtmp2)*W.dW == 0.5*(gtmp2*W.dW) + 0.5*(gtmp1*W.dW).
        # Avoid forming (gtmp1 + gtmp2), which would allocate a temporary SparseMatrixCSC.
        # Use 5-arg mul! to accumulate directly into the cached vector (allocation-free).
        mul!(nrtmp, gtmp2, W.dW, convert(eltype(nrtmp), 0.5), convert(eltype(nrtmp), 0.5))
    end

    dto2 = dt / 2
    @.. u = uprev + dto2 * (ftmp1 + ftmp2) + nrtmp
end

# weak approximation EM
@muladd function perform_step!(integrator, cache::SimplifiedEMConstantCache)
    (; t, dt, uprev, u, W, p, f) = integrator

    K = uprev .+ dt .* integrator.f(uprev, p, t)

    _dW = map(x -> calc_twopoint_random(integrator.sqdt, x), W.dW)

    if !is_diagonal_noise(integrator.sol.prob) || W.dW isa Number
        noise = integrator.f.g(uprev, p, t) * _dW
    else
        noise = integrator.f.g(uprev, p, t) .* _dW
    end

    u = K + noise
    integrator.u = u
end

@muladd function perform_step!(integrator, cache::SimplifiedEMCache)
    (; rtmp1, rtmp2, _dW) = cache
    (; t, dt, uprev, u, W, p, f) = integrator

    integrator.f(rtmp1, uprev, p, t)

    @.. u = uprev + dt * rtmp1

    integrator.f.g(rtmp2, uprev, p, t)

    if W.dW isa Union{SArray, Number}
        _dW = map(x -> calc_twopoint_random(integrator.sqdt, x), W.dW)
    else
        calc_twopoint_random!(_dW, integrator.sqdt, W.dW)
    end

    if is_diagonal_noise(integrator.sol.prob)
        @.. rtmp2 *= _dW
        @.. u += rtmp2
    else
        mul!(rtmp1, rtmp2, _dW)
        @.. u += rtmp1
    end
end

@muladd function perform_step!(integrator, cache::RKMilConstantCache)
    (; t, dt, uprev, u, W, p, f) = integrator
    du1 = integrator.f(uprev, p, t)
    K = @.. uprev + dt * du1
    L = integrator.f.g(uprev, p, t)
    mil_correction = zero(u)
    if SciMLBase.alg_interpretation(integrator.alg) == SciMLBase.AlgorithmInterpretation.Ito
        utilde = K + L * integrator.sqdt
        ggprime = (integrator.f.g(utilde, p, t) .- L) ./ (integrator.sqdt)
        mil_correction = ggprime .* (W.dW .^ 2 .- abs(dt)) ./ 2
    elseif SciMLBase.alg_interpretation(integrator.alg) ==
            SciMLBase.AlgorithmInterpretation.Stratonovich
        utilde = uprev + L * integrator.sqdt
        ggprime = (integrator.f.g(utilde, p, t) .- L) ./ (integrator.sqdt)
        mil_correction = ggprime .* (W.dW .^ 2) ./ 2
    else
        error("Algorithm interpretation invalid. Use either SciMLBase.AlgorithmInterpretation.Ito or SciMLBase.AlgorithmInterpretation.Stratonovich")
    end
    u = K + L .* W.dW + mil_correction

    if integrator.opts.adaptive
        du2 = integrator.f(K, p, t + dt)
        Ed = dt * (du2 - du1) / 2
        En = W.dW .^ 3 .* ((du2 - L) / (integrator.sqdt)) .^ 2 / 6

        resids = calculate_residuals(
            Ed, En, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.delta,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(resids, t)
    end
    integrator.u = u
end

@muladd function perform_step!(integrator, cache::RKMilCache)
    (; du1, du2, K, tmp, L) = cache
    (; t, dt, uprev, u, W, p, f) = integrator
    integrator.f(du1, uprev, p, t)
    integrator.f.g(L, uprev, p, t)

    @.. K = uprev + dt * du1
    @.. du2 = zero(eltype(u)) # This makes it safe to re-use the array
    if SciMLBase.alg_interpretation(integrator.alg) == SciMLBase.AlgorithmInterpretation.Ito
        @.. tmp = K + integrator.sqdt * L
        integrator.f.g(du2, tmp, p, t)
        @.. tmp = (du2 - L) / (2integrator.sqdt) * (W.dW .^ 2 - abs(dt))
    elseif SciMLBase.alg_interpretation(integrator.alg) ==
            SciMLBase.AlgorithmInterpretation.Stratonovich
        @.. tmp = uprev + integrator.sqdt * L
        integrator.f.g(du2, tmp, p, t)
        @.. tmp = (du2 - L) / (2integrator.sqdt) * (W.dW .^ 2)
    else
        error("Algorithm interpretation invalid. Use either SciMLBase.AlgorithmInterpretation.Ito or SciMLBase.AlgorithmInterpretation.Stratonovich")
    end
    @.. u = K + L * W.dW + tmp
    if integrator.opts.adaptive
        @.. tmp = integrator.opts.internalnorm(W.dW^3, t) *
            integrator.opts.internalnorm((du2 - L) / (integrator.sqdt), t)^2 / 6
        integrator.f(du2, K, p, t + dt)
        @.. tmp += integrator.opts.internalnorm(integrator.opts.delta * dt * (du2 - du1) / 2, t)

        calculate_residuals!(
            tmp, tmp, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(tmp, t)
    end
end

@muladd function perform_step!(integrator, cache::RKMilCommuteConstantCache)
    (; t, dt, uprev, u, W, p, f) = integrator
    dW = W.dW
    sqdt = integrator.sqdt
    Jalg = cache.Jalg

    ggprime_norm = 0.0

    J = get_iterated_I(dt, dW, W.dZ, Jalg)

    mil_correction = zero(u)
    if SciMLBase.alg_interpretation(integrator.alg) == SciMLBase.AlgorithmInterpretation.Ito
        if dW isa Number || is_diagonal_noise(integrator.sol.prob)
            J = J .- 1 // 2 .* abs(dt)
        else
            J -= 1 // 2 .* UniformScaling(abs(dt))
        end
    end

    du1 = integrator.f(uprev, p, t)
    L = integrator.f.g(uprev, p, t)

    K = uprev + dt * du1

    if is_diagonal_noise(integrator.sol.prob)
        tmp = (
            SciMLBase.alg_interpretation(integrator.alg) ==
                SciMLBase.AlgorithmInterpretation.Ito ? K : uprev
        ) .+ integrator.sqdt .* L
        gtmp = integrator.f.g(tmp, p, t)
        Dgj = (gtmp - L) / sqdt
        ggprime_norm = integrator.opts.internalnorm(Dgj, t)
        u = @.. K + L * dW + Dgj * J
    else
        for j in 1:length(dW)
            if dW isa Number
                Kj = K + sqdt * L
            else
                Kj = K + sqdt * @view(L[:, j])
            end
            gtmp = integrator.f.g(Kj, p, t)
            Dgj = (gtmp - L) / sqdt
            if integrator.opts.adaptive
                ggprime_norm += integrator.opts.internalnorm(Dgj, t)
            end
            if dW isa Number
                tmp = Dgj * J
            else
                tmp = Dgj * @view(J[:, j])
            end
            mil_correction += tmp
        end
        tmp = L * dW
        u = uprev + dt * du1 + tmp + mil_correction
    end
    if integrator.opts.adaptive
        En = integrator.opts.internalnorm(dW, t)^3 * ggprime_norm^2 / 6
        du2 = integrator.f(K, p, t + dt)
        tmp = integrator.opts.internalnorm(integrator.opts.delta * dt * (du2 - du1) / 2, t) + En

        tmp = calculate_residuals(
            tmp, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(tmp, t)
    end
    integrator.u = u
end

@muladd function perform_step!(integrator, cache::RKMilCommuteCache)
    (; du1, du2, K, gtmp, L) = cache
    (; t, dt, uprev, u, W, p, f) = integrator
    (; mil_correction, Kj, Dgj, tmp) = cache
    dW = W.dW
    sqdt = integrator.sqdt

    ggprime_norm = 0.0

    Jalg = cache.Jalg

    get_iterated_I!(dt, dW, W.dZ, Jalg)
    J = Jalg.J

    @.. mil_correction = zero(u)
    if SciMLBase.alg_interpretation(integrator.alg) == SciMLBase.AlgorithmInterpretation.Ito
        if dW isa Number || is_diagonal_noise(integrator.sol.prob)
            @.. J -= 1 // 2 * abs(dt)
        else
            J -= 1 // 2 .* UniformScaling(abs(dt))
        end
    end

    integrator.f(du1, uprev, p, t)
    integrator.f.g(L, uprev, p, t)

    @.. K = uprev + dt * du1

    if is_diagonal_noise(integrator.sol.prob)
        tmp .= (
            SciMLBase.alg_interpretation(integrator.alg) ==
                SciMLBase.AlgorithmInterpretation.Ito ? K : uprev
        ) .+ integrator.sqdt .* L
        integrator.f.g(gtmp, tmp, p, t)
        @.. Dgj = (gtmp - L) / sqdt
        ggprime_norm = integrator.opts.internalnorm(Dgj, t)
        @.. u = K + L * dW + Dgj * J
    else
        for j in 1:length(dW)
            @.. Kj = K + sqdt * @view(L[:, j]) # This works too
            #Kj .= uprev .+ sqdt*L[:,j]
            integrator.f.g(gtmp, Kj, p, t)
            @.. Dgj = (gtmp - L) / sqdt
            if integrator.opts.adaptive
                ggprime_norm += integrator.opts.internalnorm(Dgj, t)
            end
            mul!(tmp, Dgj, @view(J[:, j]))
            mil_correction .+= tmp
        end
        mul!(tmp, L, dW)
        @.. u .= uprev + dt * du1 + tmp + mil_correction
    end

    if integrator.opts.adaptive
        En = integrator.opts.internalnorm(W.dW, t)^3 * ggprime_norm^2 / 6
        integrator.f(du2, K, p, t + dt)
        @.. tmp = integrator.opts.internalnorm(
            integrator.opts.delta * dt * (du2 - du1) /
                2, t
        ) + En

        calculate_residuals!(
            tmp, tmp, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(tmp, t)
    end
end

struct EM{split} <: StochasticDiffEqAlgorithm end
EM(split = true) = EM{split}()

struct SplitEM <: StochasticDiffEqAlgorithm end

struct EulerHeun <: StochasticDiffEqAlgorithm end

struct LambaEM{split} <: StochasticDiffEqAdaptiveAlgorithm end
LambaEM(split = true) = LambaEM{split}()

struct LambaEulerHeun <: StochasticDiffEqAdaptiveAlgorithm end

struct SimplifiedEM <: StochasticDiffEqAlgorithm end

struct RKMil{interpretation} <: StochasticDiffEqAdaptiveAlgorithm end
RKMil(; interpretation = SciMLBase.AlgorithmInterpretation.Ito) = RKMil{interpretation}()

struct RKMilCommute{T} <: StochasticDiffEqAdaptiveAlgorithm
    interpretation::SciMLBase.AlgorithmInterpretation.T
    ii_approx::T
end
function RKMilCommute(; interpretation = SciMLBase.AlgorithmInterpretation.Ito, ii_approx = IICommutative())
    return RKMilCommute(interpretation, ii_approx)
end

struct PCEuler{T <: Real, F} <: StochasticDiffEqAlgorithm
    theta::T
    eta::T
    ggprime::F
end
PCEuler(ggprime; theta = 1 / 2, eta = 1 / 2) = PCEuler(theta, eta, ggprime)

struct PCEulerConstantCache <: StochasticDiffEqConstantCache end

function alg_cache(
        alg::PCEuler, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return PCEulerConstantCache()
end

@cache struct PCEulerCache{uType, rateType, rateNoiseType, rateNoiseCollectionType} <:
    StochasticDiffEqMutableCache
    utmp::uType
    ftmp::rateType
    gtmp::rateNoiseType
    gdWtmp::rateNoiseCollectionType
    bbprimetmp::rateType
end

function alg_cache(
        alg::PCEuler, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    utmp = zero(u)
    ftmp = zero(rate_prototype)
    gtmp = zero(noise_rate_prototype)
    bbprimetmp = zero(ftmp)
    if is_diagonal_noise(prob)
        gdWtmp = gtmp
    else
        gdWtmp = zero(rate_prototype)
    end
    return PCEulerCache(utmp, ftmp, gtmp, gdWtmp, bbprimetmp)
end

@muladd function perform_step!(integrator, cache::PCEulerConstantCache)
    (; t, dt, uprev, u, W, p, f) = integrator
    g = integrator.f.g
    (; theta, eta, ggprime) = integrator.alg
    dW = W.dW
    if !is_diagonal_noise(integrator.sol.prob) || W.dW isa Number
        gdW_n = g(uprev, p, t) * dW
    else
        gdW_n = g(uprev, p, t) .* dW
    end

    f_n = f(uprev, p, t)
    ubar = uprev + dt * f_n + gdW_n

    fbar_n = f_n - eta * ggprime(uprev, p, t)

    tnp1 = t + dt
    fbar_np1 = f(ubar, p, tnp1) - eta * ggprime(ubar, p, tnp1)

    if !is_diagonal_noise(integrator.sol.prob) || dW isa Number
        gdW_np1 = g(ubar, p, tnp1) * dW
    else
        gdW_np1 = g(ubar, p, tnp1) .* dW
    end

    u = uprev + (theta * dt) * fbar_np1 + ((1 - theta) * dt) * fbar_n + eta * gdW_np1 + (1 - eta) * gdW_n
    integrator.u = u
end

@muladd function perform_step!(integrator, cache::PCEulerCache)
    (; utmp, ftmp, gtmp, gdWtmp, bbprimetmp) = cache
    (; t, dt, uprev, u, W, p, f) = integrator
    g = integrator.f.g
    (; theta, eta, ggprime) = integrator.alg
    dW = W.dW

    f(ftmp, uprev, p, t)
    g(gtmp, uprev, p, t)
    ggprime(bbprimetmp, uprev, p, t)

    if is_diagonal_noise(integrator.sol.prob)
        @.. gtmp *= dW
    else
        mul!(gdWtmp, gtmp, dW)
    end

    @.. utmp = uprev + ftmp * dt + gdWtmp
    @.. u = uprev + (1 - theta) * (ftmp - eta * bbprimetmp) * dt + (1 - eta) * gdWtmp

    tnp1 = t + dt
    f(ftmp, utmp, p, tnp1)
    g(gtmp, utmp, p, tnp1)
    ggprime(bbprimetmp, utmp, p, tnp1)

    if is_diagonal_noise(integrator.sol.prob)
        @.. gtmp *= dW
    else
        mul!(gdWtmp, gtmp, dW)
    end

    @.. u += theta * (ftmp - eta * bbprimetmp) * dt + eta * gdWtmp
end

module StochasticDiffEqLowOrder

using Reexport
@reexport using StochasticDiffEqCore

import OrdinaryDiffEqCore
import OrdinaryDiffEqCore: perform_step!, initialize!, issplit

import StochasticDiffEqCore: alg_cache, alg_order, alg_compatible,
    alg_needs_extra_process, is_split_step, supports_regular_jumps,
    StochasticDiffEqAlgorithm, StochasticDiffEqAdaptiveAlgorithm,
    StochasticDiffEqCache, StochasticDiffEqConstantCache, StochasticDiffEqMutableCache,
    get_Jalg, get_iterated_I, get_iterated_I!,
    IICommutative, IILevyArea,
    calc_twopoint_random!, calc_twopoint_random,
    @cache

import DiffEqBase: is_diagonal_noise, @..
import DiffEqBase: calculate_residuals, calculate_residuals!
import DiffEqBase: full_cache, rand_cache, ratenoise_cache

import MuladdMacro: @muladd

import SciMLBase

using LinearAlgebra
using StaticArrays
using RecursiveArrayTools

include("algorithms.jl")
include("alg_utils.jl")

include("caches/basic_method_caches.jl")
include("caches/lamba_caches.jl")
include("caches/predcorr_caches.jl")

include("perform_step/low_order.jl")
include("perform_step/lamba.jl")
include("perform_step/predcorr.jl")
include("perform_step/split.jl")

export EM, SplitEM, EulerHeun, LambaEM, LambaEulerHeun,
    SimplifiedEM, RKMil, RKMilCommute, PCEuler

end # module

@muladd function perform_step!(integrator, cache::LambaEMConstantCache)
    (; t, dt, uprev, u, W, p, f) = integrator
    du1 = integrator.f(uprev, p, t)
    K = @.. uprev + dt * du1

    if is_split_step(integrator.alg)
        L = integrator.f.g(uprev, p, t + dt)
    else
        L = integrator.f.g(K, p, t + dt)
    end

    mil_correction = zero(u)
    if !is_diagonal_noise(integrator.sol.prob) || W.dW isa Number
        noise = L * W.dW
    else
        noise = L .* W.dW
    end

    u = K + noise

    if integrator.opts.adaptive
        du2 = integrator.f(K, p, t + dt)
        Ed = dt * (du2 - du1) / 2

        utilde = K + noise * integrator.sqdt #L*integrator.sqdt
        ggprime = (integrator.f.g(utilde, p, t) .- L) ./ (integrator.sqdt)
        if !is_diagonal_noise(integrator.sol.prob) || W.dW isa Number
            En = ggprime * (W.dW .^ 2 .- dt) ./ 2
        else
            En = ggprime .* (W.dW .^ 2 .- dt) ./ 2
        end
        resids = calculate_residuals(
            Ed, En, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.delta,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(resids, t)
    end

    integrator.u = u
end

@muladd function perform_step!(integrator, cache::LambaEMCache)
    (; du1, du2, K, tmp, L, gtmp, dW_cache) = cache
    (; t, dt, uprev, u, W, p, f) = integrator

    integrator.f(du1, uprev, p, t)
    @.. K = uprev + dt * du1

    if is_split_step(integrator.alg)
        integrator.f.g(L, K, p, t + dt)
    else
        integrator.f.g(L, uprev, p, t + dt)
    end

    if is_diagonal_noise(integrator.sol.prob)
        @.. tmp = L * W.dW
    else
        mul!(tmp, L, W.dW)
    end

    @.. u = K + tmp

    if integrator.opts.adaptive
        if !is_diagonal_noise(integrator.sol.prob)
            g_sized = norm(L, 2)
        else
            g_sized = L
        end

        if !is_diagonal_noise(integrator.sol.prob)
            @.. tmp = K + integrator.sqdt * g_sized
            integrator.f.g(gtmp, tmp, p, t)
            g_sized2 = norm(gtmp, 2)
            @.. dW_cache = W.dW .^ 2 - dt
            diff_tmp = integrator.opts.internalnorm(dW_cache, t)
            En = (g_sized2 - g_sized) / (2integrator.sqdt) * diff_tmp
            @.. tmp = En
        else
            @.. tmp = K + integrator.sqdt * L
            integrator.f.g(gtmp, tmp, p, t)
            @.. tmp = (gtmp - L) / (2integrator.sqdt) * (W.dW .^ 2 - dt)
        end

        # Ed
        integrator.f(du2, K, p, t + dt)
        @.. tmp += integrator.opts.internalnorm(
            integrator.opts.delta * dt * (du2 - du1) /
                2, t
        )

        calculate_residuals!(
            tmp, tmp, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(tmp, t)
    end
end

@muladd function perform_step!(integrator, cache::LambaEulerHeunConstantCache)
    (; t, dt, uprev, u, W, p, f) = integrator
    du1 = integrator.f(uprev, p, t)
    K = uprev + dt * du1
    L = integrator.f.g(uprev, p, t)

    if is_diagonal_noise(integrator.sol.prob)
        noise = L .* W.dW
    else
        noise = L * W.dW
    end
    tmp = K .+ noise
    gtmp2 = (1 / 2) .* (L .+ integrator.f.g(tmp, p, t + dt))
    if is_diagonal_noise(integrator.sol.prob)
        noise2 = gtmp2 .* W.dW
    else
        noise2 = gtmp2 * W.dW
    end

    u = uprev .+ (dt / 2) .* (du1 .+ integrator.f(tmp, p, t + dt)) .+ noise2

    if integrator.opts.adaptive
        du2 = integrator.f(K, p, t + dt)
        Ed = dt * (du2 - du1) / 2

        utilde = uprev + L * integrator.sqdt
        ggprime = (integrator.f.g(utilde, p, t) .- L) ./ (integrator.sqdt)
        En = ggprime .* (W.dW .^ 2) ./ 2

        resids = calculate_residuals(
            Ed, En, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.delta,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(resids, t)
    end

    integrator.u = u
end

@muladd function perform_step!(integrator, cache::LambaEulerHeunCache)
    (; du1, du2, K, tmp, L, gtmp, dW_cache) = cache
    (; t, dt, uprev, u, W, p, f) = integrator
    integrator.f(du1, uprev, p, t)
    integrator.f.g(L, uprev, p, t)
    @.. K = uprev + dt * du1

    if is_diagonal_noise(integrator.sol.prob)
        @.. tmp = L * W.dW
    else
        mul!(tmp, L, W.dW)
    end

    @.. tmp = K + tmp

    integrator.f(du2, tmp, p, t + dt)
    integrator.f.g(gtmp, tmp, p, t + dt)

    if is_diagonal_noise(integrator.sol.prob)
        @.. tmp = (1 / 2) * W.dW * (L + gtmp)
    else
        @.. gtmp = (1 / 2) * (L + gtmp)
        mul!(tmp, gtmp, W.dW)
    end

    dto2 = dt * (1 / 2)
    @.. u = uprev + dto2 * (du1 + du2) + tmp

    if integrator.opts.adaptive
        if !is_diagonal_noise(integrator.sol.prob)
            g_sized = norm(L, 2)
        else
            g_sized = L
        end

        if !is_diagonal_noise(integrator.sol.prob)
            @.. tmp = uprev + integrator.sqdt * g_sized
            integrator.f.g(gtmp, tmp, p, t)
            g_sized2 = norm(gtmp, 2)
            @.. dW_cache = W.dW .^ 2
            diff_tmp = integrator.opts.internalnorm(dW_cache, t)
            En = (g_sized2 - g_sized) / (2integrator.sqdt) * diff_tmp
            @.. tmp = En
        else
            @.. tmp = uprev + integrator.sqdt * L
            integrator.f.g(gtmp, tmp, p, t)
            @.. tmp = (gtmp - L) / (2integrator.sqdt) * (W.dW .^ 2)
        end

        # Ed
        integrator.f(du2, K, p, t + dt)
        @.. tmp += integrator.opts.internalnorm(
            integrator.opts.delta * dt * (du2 - du1) /
                2, t
        )

        calculate_residuals!(
            tmp, tmp, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(tmp, t)
    end
end

using SafeTestsets

const TEST_GROUP = get(ENV, "ODEDIFFEQ_TEST_GROUP", "ALL")

if TEST_GROUP == "ALL" || TEST_GROUP == "Core"
    @time @safetestset "Module loads" begin
        using StochasticDiffEqLowOrder
        using Test

        @test isdefined(StochasticDiffEqLowOrder, :EM)
        @test isdefined(StochasticDiffEqLowOrder, :EulerHeun)
        @test isdefined(StochasticDiffEqLowOrder, :LambaEM)
        @test isdefined(StochasticDiffEqLowOrder, :LambaEulerHeun)
        @test isdefined(StochasticDiffEqLowOrder, :SimplifiedEM)
        @test isdefined(StochasticDiffEqLowOrder, :SplitEM)
        @test isdefined(StochasticDiffEqLowOrder, :RKMil)
        @test isdefined(StochasticDiffEqLowOrder, :RKMilCommute)
        @test isdefined(StochasticDiffEqLowOrder, :PCEuler)
    end
end

struct EMConstantCache <: StochasticDiffEqConstantCache end
@cache struct EMCache{uType, rateType, rateNoiseType} <: StochasticDiffEqMutableCache
    u::uType
    uprev::uType
    tmp::uType
    rtmp1::rateType
    rtmp2::rateNoiseType
end

function alg_cache(
        alg::EM, prob, u, ΔW, ΔZ, p, rate_prototype, noise_rate_prototype,
        jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return EMConstantCache()
end

function alg_cache(
        alg::EM, prob, u, ΔW, ΔZ, p, rate_prototype, noise_rate_prototype,
        jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    rtmp1 = zero(rate_prototype)
    if noise_rate_prototype !== nothing
        rtmp2 = zero(noise_rate_prototype)
    else
        rtmp2 = nothing
    end
    return EMCache(u, uprev, tmp, rtmp1, rtmp2)
end

struct SplitEMConstantCache <: StochasticDiffEqConstantCache end
@cache struct SplitEMCache{uType, rateType, rateNoiseType} <: StochasticDiffEqMutableCache
    u::uType
    uprev::uType
    tmp::uType
    rtmp1::rateType
    rtmp2::rateNoiseType
end

function alg_cache(
        alg::SplitEM, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SplitEMConstantCache()
end

function alg_cache(
        alg::SplitEM, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    rtmp1 = zero(rate_prototype)
    rtmp2 = zero(noise_rate_prototype)
    return SplitEMCache(u, uprev, tmp, rtmp1, rtmp2)
end

struct EulerHeunConstantCache <: StochasticDiffEqConstantCache end
@cache struct EulerHeunCache{uType, rateType, rateNoiseType, rateNoiseCollectionType} <:
    StochasticDiffEqMutableCache
    u::uType
    uprev::uType
    tmp::uType
    ftmp1::rateType
    ftmp2::rateType
    nrtmp::rateNoiseCollectionType
    gtmp1::rateNoiseType
    gtmp2::rateNoiseType
end

function alg_cache(
        alg::EulerHeun, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return EulerHeunConstantCache()
end

function alg_cache(
        alg::EulerHeun, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    ftmp1 = zero(rate_prototype)
    ftmp2 = zero(rate_prototype)
    nrtmp = zero(rate_prototype)
    gtmp1 = zero(noise_rate_prototype)
    gtmp2 = zero(noise_rate_prototype)
    return EulerHeunCache(u, uprev, tmp, ftmp1, ftmp2, nrtmp, gtmp1, gtmp2)
end

struct SimplifiedEMConstantCache <: StochasticDiffEqConstantCache end
@cache struct SimplifiedEMCache{randType, uType, rateType, rateNoiseType} <:
    StochasticDiffEqMutableCache
    u::uType
    uprev::uType
    _dW::randType
    rtmp1::rateType
    rtmp2::rateNoiseType
end

function alg_cache(
        alg::SimplifiedEM, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SimplifiedEMConstantCache()
end

function alg_cache(
        alg::SimplifiedEM, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        _dW = copy(ΔW)
    else
        _dW = zero(ΔW)
    end

    rtmp1 = zero(rate_prototype)
    rtmp2 = zero(noise_rate_prototype)
    return SimplifiedEMCache(u, uprev, _dW, rtmp1, rtmp2)
end

struct RKMilConstantCache <: StochasticDiffEqConstantCache end
@cache struct RKMilCache{uType, rateType} <: StochasticDiffEqMutableCache
    u::uType
    uprev::uType
    du1::rateType
    du2::rateType
    K::rateType
    tmp::uType
    L::rateType
end

function alg_cache(
        alg::RKMil, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return RKMilConstantCache()
end

function alg_cache(
        alg::RKMil, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    du1 = zero(rate_prototype)
    du2 = zero(rate_prototype)
    K = zero(rate_prototype)
    tmp = zero(u)
    L = zero(rate_prototype)
    return RKMilCache(u, uprev, du1, du2, K, tmp, L)
end

struct RKMilCommuteConstantCache{JalgType} <: StochasticDiffEqConstantCache
    Jalg::JalgType
end
@cache struct RKMilCommuteCache{uType, rateType, rateNoiseType, JalgType} <:
    StochasticDiffEqMutableCache
    u::uType
    uprev::uType
    du1::rateType
    du2::rateType
    K::rateType
    gtmp::rateNoiseType
    L::rateNoiseType
    Jalg::JalgType
    mil_correction::rateType
    Kj::uType
    Dgj::rateNoiseType
    tmp::uType
end

function alg_cache(
        alg::RKMilCommute, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    Jalg = get_Jalg(ΔW, dt, prob, alg)
    return RKMilCommuteConstantCache{typeof(Jalg)}(Jalg)
end

function alg_cache(
        alg::RKMilCommute, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    du1 = zero(rate_prototype)
    du2 = zero(rate_prototype)
    K = zero(rate_prototype)
    gtmp = zero(noise_rate_prototype)
    L = zero(noise_rate_prototype)
    tmp = zero(rate_prototype)
    Jalg = get_Jalg(ΔW, dt, prob, alg)
    mil_correction = zero(rate_prototype)
    Kj = zero(u)
    Dgj = zero(noise_rate_prototype)
    return RKMilCommuteCache(u, uprev, du1, du2, K, gtmp, L, Jalg, mil_correction, Kj, Dgj, tmp)
end

struct LambaEMConstantCache <: StochasticDiffEqConstantCache end
@cache struct LambaEMCache{uType, rateType, rateNoiseType, randType} <:
    StochasticDiffEqMutableCache
    u::uType
    uprev::uType
    du1::rateType
    du2::rateType
    K::rateType
    tmp::uType
    L::rateNoiseType
    gtmp::rateNoiseType
    dW_cache::randType
end

function alg_cache(
        alg::LambaEM, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return LambaEMConstantCache()
end

function alg_cache(
        alg::LambaEM, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    du1 = zero(rate_prototype)
    du2 = zero(rate_prototype)
    K = zero(rate_prototype)
    tmp = zero(u)
    L = zero(noise_rate_prototype)
    gtmp = zero(noise_rate_prototype)
    if is_diagonal_noise(prob)
        dW_cache = nothing
    else
        dW_cache = zero(ΔW)
    end
    return LambaEMCache(u, uprev, du1, du2, K, tmp, L, gtmp, dW_cache)
end

struct LambaEulerHeunConstantCache <: StochasticDiffEqConstantCache end
@cache struct LambaEulerHeunCache{uType, rateType, rateNoiseType, randType} <:
    StochasticDiffEqMutableCache
    u::uType
    uprev::uType
    du1::rateType
    du2::rateType
    K::rateType
    tmp::uType
    L::rateNoiseType
    gtmp::rateNoiseType
    dW_cache::randType
end

function alg_cache(
        alg::LambaEulerHeun, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return LambaEulerHeunConstantCache()
end

function alg_cache(
        alg::LambaEulerHeun, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    du1 = zero(rate_prototype)
    du2 = zero(rate_prototype)
    K = zero(rate_prototype)
    tmp = zero(u)
    L = zero(noise_rate_prototype)
    gtmp = zero(noise_rate_prototype)
    if is_diagonal_noise(prob)
        dW_cache = nothing
    else
        dW_cache = zero(ΔW)
    end
    return LambaEulerHeunCache(u, uprev, du1, du2, K, tmp, L, gtmp, dW_cache)
end
